(动态规划) leetcode 53 最大子序列之和,LCS:最长公共子串长,568 Maximum Vacation Days 最大化休假日

(动态规划) leetcode 53 最大子序列之和,LCS:最长公共子串长,568 Maximum Vacation Days 最大化休假日

思路:nums为给定的数组,动态规划:

设 一维数组:dp[i] 表示 以第i个元素为结尾的一段最大子序和。

1)若dp[i-1]小于0,则dp[i]加上前面的任意长度的序列和都会小于nums[i],则 dp[i] = nums[i];

2)  若dp[i-1] 不小于0, 则 dp[i] = dp[i-1] + nums[i];

边界条件:dp[0] = nums[0]  (nums数组的第一个元素的最大长度就是本身)

class Solution {
public:
    int maxSubArray(vector<int>& nums) {
        int len = nums.size();
        if(len == 0) return 0;
        if(len == 1) return nums[0];
        vector<int> dp(len, 0);  //dp[i]: 以第i个元素为结尾的最大子序列和
        dp[0] = nums[0];
        int max_num = dp[0];
        for(int i=1; i<len; i++){
            if(dp[i-1] > 0)
                dp[i] = dp[i-1] +nums[i];
            else
                dp[i] = nums[i];
            max_num = max(max_num, dp[i]);
        }
        return max_num;
    }
};

 最长公共子序列:

(动态规划) leetcode 53 最大子序列之和,LCS:最长公共子串长,568 Maximum Vacation Days 最大化休假日

(动态规划) leetcode 53 最大子序列之和,LCS:最长公共子串长,568 Maximum Vacation Days 最大化休假日

 https://www.nowcoder.com/courses/6/8/3

#include<bits/stdc++.h>
using namespace std;
int longestsub(string a, string b){
    int a_s = a.size(), b_s = b.size();
    int N = (a_s >= b_s)? a_s: b_s;
    int dp[N+1][N+1];
    memset(dp, 0, sizeof(dp));
    if(a_s<=0 || b_s<=0)
        return 0;
    for(int i=1; i<=a_s; i++){
        for(int j=1; j<=b_s; j++){
            if(a[i-1]==b[j-1])
                dp[i][j] = dp[i-1][j-1]+1;
            else
                dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
            //cout<<dp[i][j]<<" ";
        }
        //cout<<endl;
    }
    return dp[a_s][b_s];
}
int main(){
    string a, b;
    while(cin>>a>>b){
        int res = longestsub(a,b);
        cout<<res<<endl;
    }
    return 0;
}

 568 Maximum Vacation Days 最大化休假日

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation: 
Ans = 6 + 3 + 3 = 12.
One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation: 
Ans = 1 + 1 + 1 = 3.
Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.

Example 3:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21
One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.

题目大意:

给定N个城市,K周时间。
矩阵flights描述N个城市之间是否存在航班通路。
若flights[i][j] = 1,表示i与j存在通路,否则表示不存在。特别的,flights[i][i]恒等于0。
矩阵days表示可以在某城市逗留的最长天数。
例如days[i][j] = k,表示第i个城市第j周最长可以逗留k天。
初始位于0号城市,每周可以选择一个能够到达的城市逗留(也可以留在当前城市)。
求最优策略下的最长逗留总天数。
注意:
  1. N和K是正整数,范围[1, 100]
  2. 矩阵flights的元素范围[0, 1]
  3. 矩阵days的元素范围[0, 7]

思路:

解题思路:

动态规划(Dynamic Programming)
dp[w][c]表示第w周选择留在第c个城市可以获得的最大总收益

初始令dp[w][0] = 0, dp[w][1 .. c - 1] = -1

当dp[w][c] < 0时,表示第c个城市在第w周时还不可达。
状态转移方程:
for w in (0 .. K)
    for sc in (0 .. N)
        if dp[w][sc] < 0:
            continue
        for tc in (0 .. N)
            if sc == tc or flights[sc][tc] == 1:
                dp[w + 1][tc] = max(dp[w + 1][tc], dp[w][sc] + days[tc][w])
class Solution {
public:
    int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
        int N = flights.size();
        int K = days[0].size();
        
        vector<vector<int>> dp(K, vector<int>(N, 0));
        vector<vector<bool>> reach(K, vector<bool>(N, false));

        // first week, no guesses for the previous city
        for (int city = 0; city < N; ++city)
            if (city == 0 || flights[0][city]) {
                dp[0][city] = days[city][0];  //第0周留在city可获得的最大收益==在city逗留的最大天数
                reach[0][city] = true;  //第0周可达city
            }
        
        
        // topological order (week)
        for (int week = 1; week < K; ++week) {
            // current city
            for (int city = 0; city < N; ++city) {
                // Subproblem: guess a previous city
                for (int prevCity = 0; prevCity < N; ++prevCity) {
                    if (reach[week - 1][prevCity] && (city == prevCity || flights[prevCity][city])) {
                        dp[week][city] = max(dp[week][city], dp[week - 1][prevCity] + days[city][week]);
                        reach[week][city] = true;
                    }   
                }
            }
        }
        
        int res = 0;
        for (int city = 0; city < N; ++city)
            res = max(res, dp[K - 1][city]);
        
        return res;
        
    }
    
};